/* support for pulling force added <2000-06-21 rbund> */
/* to use doubles instead of floats in pf_fold() uncomment next line */
#define LARGE_PF
#ifdef  LARGE_PF
#define FLT_OR_DBL double
#else
#define FLT_OR_DBL float
#endif

/* parameters for nucleocapsid binding */
extern int footprint; /* binding site size (nucleotides) */
extern double NC_Energy_ext; /* binding energy for external bases (kcal/mol) */
extern double NC_Energy_loop; /* binding energy inside loops (kcal/mol) */
extern double R_FRET; /* FRET radius for Cy3-Cy5 (nm) */
extern double C_NC; /* Nucleocapsid concentration (M) */
extern int High_NC_pos ; /* start position of high affinity NC binding site */
extern double High_NC_energy; /* extra binding energy for high affinity NC binding site (kcal/mol) */
extern double exp_E_NC_DS; /*free energy for NC binding to dsDNA*/
extern double footprintDS; /*footprint for NC binding to dsDNA*/

//FLT_OR_DBL *pNCr;         /* probability NC is bound at each base */

extern double * exp_dmu; 	/*deviation from average binding energy for NC bound starting at each base*/
extern double * exp_dmuDS; 	/*deviation from average binding energy for NC bound starting at each base*/

extern int  noGU;           /* GU not allowed at all */
extern int  no_closingGU;   /* GU allowed only inside stacks */
extern int  tetra_loop;     /* Fold with specially stable 4-loops */
extern int  energy_set;     /* 0 = BP; 1=any mit GC; 2=any mit AU-parameter */
extern int  dangles;	    /* use dangling end energies (not in part_func!) */
/*@null@*/
extern char *nonstandards;  /* contains allowed non standard bases */
extern double temperature;   /* rescale parameters to this temperature */
extern float force;         /* applied force in pN */
extern float salt;          /* monovalent salt concentration in M */
extern int extstemenergy;  /*free energy of external stems (in 0.01 kcal/mol)*/
extern int  james_rule;     /* interior loops of size 2 get energy 0.8Kcal and
			       no mismatches, default 1 */
extern int  logML;          /* use logarithmic multiloop energy function */

struct bond {               /* base pair */
   int i;
   int j;
};
            
extern struct bond  *base_pair; /* list of base pairs */

extern FLT_OR_DBL *pr;          /* base pairing prob. matrix */
extern int   *iindx;            /* pr[i,j] -> pr[iindx[i]-j] */
extern FLT_OR_DBL *fx;          /* fixed extension free energy vector        */
extern FLT_OR_DBL *fmn;         /* fixed extension free energy matrix        */
extern FLT_OR_DBL *fmnb;        /* backwards fixed ext. free energy matrix   */
extern FLT_OR_DBL *fl;          /* free energy at different length */
extern double pf_scale;         /* scaling factor to avoid float overflows   */
extern int    fold_constrained; /* fold with constraints                     */
extern int    do_backtrack;     /* calculate pair prob matrix in part_func() */
extern int    do_fixedextension;/* calculate fixed ext. weight in part_func()*/
extern int    do_autoscale;     /* determine pf_scale automatically          */
extern int    open_bases;       /* number of open bases in backtracking or -1*/
extern int    subtract_one;     /* subtract a one from Boltzmann factors     */
extern int    do_polymer;       /* emulate polymer contribution to force     */
extern int    return_alllengths;/* return all restricted partition functions */
extern int    noLonelyPairs;    /* avoid helices of length 1 */
extern char backtrack_type;     /* usually 'F'; 'C' require (1,N) to be bonded;
				   'M' seq is part of a multi loop */
char * option_string(void);
